/**
 *
 */
package de.intevation.gnv.action;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import de.intevation.gnv.action.sessionmodel.SessionModel;
import de.intevation.gnv.action.sessionmodel.SessionModelFactory;
import de.intevation.gnv.artifactdatabase.client.ArtifactDatabaseClient;
import de.intevation.gnv.artifactdatabase.client.ArtifactDatabaseClientFactory;
import de.intevation.gnv.artifactdatabase.objects.ArtifactDescription;
import de.intevation.gnv.artifactdatabase.objects.DefaultInputParameter;
import de.intevation.gnv.artifactdatabase.objects.InputParameter;
import de.intevation.gnv.util.XSLTransformer;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 *
 */
public class NextArtifactStepAction extends ArtifactDatabaseActionBase {
    /**
     * the logger, used to log exceptions and additonaly information
     */
    private static Logger log = Logger.getLogger(SelectArtifactFactoryAction.class);
    
    /**
     * Constructor
     */
    public NextArtifactStepAction() {
        super();
    }

    /**
     * @see de.intevation.gnv.action.ArtifactDatabaseActionBase#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     */
    @Override
    public ActionForward execute(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response)
            throws Exception {
        SessionModel sm = SessionModelFactory.getInstance().getSessionModel(request);
        ArtifactDescription ad = (ArtifactDescription)sm.getCurrentArtifact();
        Collection<String> inputParameter = ad.getInputParameter();
        Collection<InputParameter> ips = null;
        if (inputParameter != null){
            ips = new ArrayList<InputParameter>(inputParameter.size());
            Iterator<String> it = inputParameter.iterator();
            while (it.hasNext()){
                String name = it.next();
                String[] values = request.getParameterValues(name);
                InputParameter ip = new DefaultInputParameter(name, values);
                ips.add(ip);
            }
        }
        ArtifactDatabaseClient adc = ArtifactDatabaseClientFactory.getInstance().getArtifactDatabaseClient();
        if (ad.getReachableStates() != null && !ad.getReachableStates().isEmpty()){
            // TODO: Woher kommt der zu erreichende Status;
            String target = ad.getReachableStates().iterator().next();
                    
            
            ArtifactDescription artifactDescription = adc.doNextStep(sm.getSelectedArtifactFactory(), sm.getCurrentArtifact(), target, ips);
            
            XSLTransformer transformer = new XSLTransformer();
            String ui = transformer.transform(artifactDescription.getCurrentUI(), "UTF-8", request.getRealPath("WEB-INF/config/templates/describe-ui.xsl"));
            
            request.setAttribute("ui", ui);
        }else{
            
            adc.doFeed(sm.getSelectedArtifactFactory(), sm.getCurrentArtifact(), ips);
            String mimeType = "image/png";
            String target = "chart";
                
            String src = "<img src='out.do?mimetype="+mimeType+"&target="+target+"&uid="+System.currentTimeMillis()+"' alt='Chart'>";
            request.setAttribute("ui", src);
            
        }
        
        return super.execute(mapping, form, request, response);
    }
    

}
